  subroutine rdchang_flame_soot(nopr,iout,indir,outdir,lstrn,iset,&
  lset,llset,nlines,wcm,wavelength,rndat,ridat,iwave)

! ******
! Read in the data from the netCDF file

! ****
! Will use netCDF f90 routines
  use netcdf

! param1.inc gives the maximum size of indices and extinction vectors
  include 'param1.inc'

! ****
! See rdinoutdir.f90
  character(len=60) :: indir,outdir
  integer :: nopr,iout,iset

! See main.f90
  integer :: nlines,iwave
  real :: wcm(nwavemax),wavelength(nwavemax)
  real :: rndat(nwavemax),ridat(nwavemax)
  character(len=100) :: lstrn,lset,filnm

! Used here
  integer,parameter :: ndat=13,ncomp=3
  integer :: id1,istat,noprf,mset,itemp,i1,i2
  integer :: idwcm,idwave,idrn,idri,idtk
  integer :: start(1),count(1),stride(1)
  integer :: start2(2),count2(2),stride2(2)
  integer :: nheight,nwave
  integer :: ntext,n70,iheight
  real :: wcmdat(ndat),wavedat(ndat)
  real :: rnval(ndat,ncomp),rival(ndat,ncomp)
  character(len=30) :: fil
  character (len=16) :: files(ncomp),llset

! ***
! Read in the data from the netCDF file
   lset=lstrn

! ***
! The input netCDF file
!     '123456789012345678901234567890'
  fil='chang_flame_soot.nc           '

! Obtain the full pathname of the input netCDF file
   noprf=0
  call getfilnm(noprf,iout,fil,indir,filnm)
  if (noprf .eq. 1) then
   stop
  end if

! ***
! Open the netCDF file
  istat=nf90_open(filnm,nf90_nowrite,id1)
   call handle(iout,istat)

  if (nopr .eq. 1) then
   write(iout,fmt=100) id1,filnm
   100 format(/,2x,"rdchang_flame_soot: id1,filnm ",i8,2x,a100)
  end if

! ***
! Get dimension ids (work with variables part of ncdump)
  istat=nf90_inq_varid(id1,'nwave',idnwave)
   call handle(iout,istat)
  istat=nf90_inq_varid(id1,'nheight',idnheight)
   call handle(iout,istat)
  istat=nf90_inq_varid(id1,'ntext',idntext)
   call handle(iout,istat)
  istat=nf90_inq_varid(id1,'n70',idn70)
   call handle(iout,istat)

! *****
! Get the dimensions
  istat=nf90_get_var(id1,idnwave,nwave)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idnheight,nheight)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idntext,ntext)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idn70,n70)
   call handle(iout,istat)
  
  if (nopr .eq. 1) then
   write(iout,fmt=110) nwave,nheight
   110 format(/,2x,"nwave,nheight ",/,&
   2x,4(1x,i4))
   write(iout,fmt=120) ntext,n70
   120 format(/,2x,"ntext,n70",/,&
   2x,2(1x,i4))
  end if

! ***
! Obtain the listing of the compounds
! Will ask the user to choose which compound to work with

! The different compositions
!          '1234567890123456'
  files(1)=' 6 mm           '
  files(2)=' 8 mm           '
  files(3)=' 10 mm          '

! *
! Write out the compounds included in the netCDF file
  write(0,fmt=140)
  140 format(2x," Will select mset value for a specific measurement")
  write(0,fmt=145)
  145 format(2x," i, height in mm above flame")

  do i=1,ncomp
   write(0,fmt=150) i,files(i)
   150 format(2x,i3,2x,a16)
  end do

  write(0,fmt=160)
  160 format(2x,"Specify mset (1-3) e.g. mset=1 for 8 mm case ")

  read(5,*) mset
  mset=int(mset)

! The compound string
  llset=files(mset)

  write(0,fmt=170) mset,llset
  170 format(2x," mset,llset ",i4,2x,a16)

! ***
! Obtain variable ids
    nlines=ndat
   istat=nf90_inq_varid(id1,'wcmflame',idwcm)
    call handle(iout,istat)
   istat=nf90_inq_varid(id1,'wmicflame',idwave)
    call handle(iout,istat)
   istat=nf90_inq_varid(id1,'rnflame',idrn)
    call handle(iout,istat)
   istat=nf90_inq_varid(id1,'riflame',idri)
    call handle(iout,istat)
   istat=nf90_inq_varid(id1,'height',idheight)
    call handle(iout,istat)

  if (nopr .eq. 1) then
   write(0,fmt=190) nlines,idwcm,idwave,idrn,idri,idheight
   write(iout,fmt=190) nlines,idwcm,idwave,idrn,idri,idheight
   190 format(/,2x,"nlines, idwcm,idwave,idrn,idri,idtheightk ",/,&
   2x,1(1x,i4),2x,5(1x,i4))
  end if 

! ****
!  Read in the data

! The wavenumber and wavelengths
   start(1)=1
   count(1)=ndat
   stride(1)=1
  istat=nf90_get_var(id1,idwcm,wcmdat,start,count,stride)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idwave,wavedat,start,count,stride)
   call handle(iout,istat)

! All of the indices
   start2(1)=1
   start2(2)=1
   count2(1)=ndat
   count2(2)=ncomp
   stride2(1)=1
   stride2(2)=1
  istat=nf90_get_var(id1,idrn,rnval,start2,count2,stride2)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idri,rival,start2,count2,stride2)
   call handle(iout,istat)

! ****
! Exit define mode
  istat=nf90_enddef(id1)

! Close the data set
  istat=nf90_close(id1)

! *****
! Put values into the output arrays
  do i=1,nlines
   wcm(i)=wcmdat(i)
   wavelength(i)=wavedat(i)
   rndat(i)=rnval(i,mset)
   ridat(i)=rival(i,mset)
  end do

! *****
  if (nopr .eq. 1) then
    write(iout,fmt=800) mset,files(mset)
    800 format(/,2x,"rdchang_flame_soot: work with mset, files(mset)",/,&
    2x,i3,2x,a16)
    write(iout,fmt=840)
    840 format(2x,"rdchang_flame_soot: i,wcm,wavelength,rndat,ridat")
   do i=1,nlines 
    write(iout,fmt=850) i,wcm(i),wavelength(i),rndat(i),ridat(i)
    850 format(2x,i4,2(1x,f10.4),1p,2(1x,e10.3))
   end do
  end if

! ******
  return
  end


